// http://lans.kirov.ru/index.php?mod=doc&docid=13

#pragma comment(linker,"/subsystem:Windows,5")
#pragma comment(linker,"/version:5")


#define WINVER       0x0500
#define _WIN32_WINNT 0x0500
//#define UNICODE
//#define _UNICODE

#include <windows.h>
#include <Lmcons.h>
#include "resource.h"
#include <commctrl.h>
#include <richedit.h>
#include "CRCFileCheck.h"
#include "RC4.h"
#include "StrToNum.h"
#include "DebugFunctions.h"
#include "ListMT.h"
#include "MemoryFind.h"
#include "MemoryFindByte.h"
#include "MemoryCompare.h"
#include "ReportError.h"

#pragma comment(lib, "comctl32.lib")




#define FILETIME_SECOND			((DWORDLONG)10000000)
#define FILETIME_MINUTE			((DWORDLONG)FILETIME_SECOND*60)
#define MAIN_WINDOW_MIN_WIGTH	550
#define MAIN_WINDOW_MIN_HEIGHT	300
#define MAX_PATH_LEN			32768L
#define CHECK_TIMER_INTERVAL	10 // mseconds
#define REFRESH_TIMER_INTERVAL	(1000*60)
#define UL_USER_UPDATE_TIME		30 // seconds
#define UL_RETRY_COUNT_MAX		8
#define UL_RETRY_PING_WAIT		16 // seconds


#define IC_HEAD_SIZE		8
static const BYTE IC_HEAD[8]={19,'i','C','h','a','t',19,19};
static const BYTE IC_HEAD_AH[8]={19,'i','C','h','i','t',19,19};

#define IC_CH_VER_IGNORY	-1
#define IC_CH_VER_ORIG		0
#define IC_CH_VER_ANTIHACK	1
#define IC_CH_VER_UNKNOWN	2
static const BYTE* IC_HEADS[]=
{
	IC_HEAD,
	IC_HEAD_AH
};

static const LPSTR lpcszSoftwareVersion[]=
{
	"Original",
	"Anti hack",
	"Unknown"
};

#define ICDELIMITER			4883
#define IC_RC4_PASS			"tahci"
#define IC_MAIN_CHANNEL		"iTCniaM"
#define IC_PRIVATE			"gsMTCI"

#define IC_STATUS_ONLINE	0
#define IC_STATUS_DND		1
#define IC_STATUS_OCCUPIED	2
#define IC_STATUS_AWAY		3
#define IC_STATUS_INVISIBLE	4
#define IC_STATUS_OFFLINE	5

static const LPSTR lpcszStatus[]=
{
	"Online",
	"DND",
	"Occupied",
	"Away",
	"Invisible",
	"Offline"
};


#define IC_CMD_DISCONNECT	0
#define IC_CMD_CONNECT		1
#define IC_CMD_CREATE_LINE	2
#define IC_CMD_REFRESH		3
#define IC_CMD_STATUS_REQ	4
#define IC_CMD_STATUS		5
#define IC_CMD_BOARD		6
#define IC_CMD_TEXT			7
#define IC_CMD_ME			8
#define IC_CMD_RECIEVED		9
#define IC_CMD_RENAME		10
#define IC_MAX_CMD			(IC_CMD_RENAME+1)

static const LPSTR lpcszCmd[IC_MAX_CMD]=
{
	"DISCONNECT",
	"CONNECT",
	"CREATE_LINE",
	"REFRESH",
	"STATUS_REQ",
	"STATUS",
	"BOARD",
	"TEXT",
	"ME",
	"RECIEVED",
	"RENAME"
};

static const SIZE_T dwcCmdSize[IC_MAX_CMD]=
{
	10,
	7,
	11,
	7,
	10,
	6,
	5,
	4,
	2,
	8,
	6
};





struct USER_DATA
{
	LIST_MT_ITEM	lmtListMTItem;
	SYSTEMTIME		stLastUpdateTime;
	DWORD			dwRetryCount;
	BOOL			bOwner;
	HWND			hInfoWindow;

	char			szNick[MAX_PATH];
	SIZE_T			dwNickLen;
	char			szLogin[(UNLEN+4)];
	SIZE_T			dwLoginLen;
	char			szComputerName[(MAX_COMPUTERNAME_LENGTH+4)];
	SIZE_T			dwComputerNameLen;
	char			szStatusMSG[MAX_PATH];
	SIZE_T			dwStatusMSGLen;
	char			szVersion[MAX_PATH];
	SIZE_T			dwVersionLen;
    DWORD			dwStatus;
	DWORD			dwSoftwareVersion;
	DWORD			dwCmdNum;
};


//    
struct PROCESS_SETTINGS
{
	HINSTANCE					hInstance;						// * 
	HANDLE						hMemAllocHandle;				// *heap for fast allocate memory
	HWND						hMainWindow;					// *
	HWND						hLogWindow;						// *
	HWND						hUsersListWindow;				// *
	HWND						hWndSendText;					// *
	UINT_PTR					uiMailSlotReadTimer;			// *
	UINT_PTR					uiRefreshTimer;					// *
	LONG_PTR					lngOldSendTextProc;				// *
	HIMAGELIST					hSmallIcons;

	BOOL						bShowExtendedInfo;

	DWORD						dwSoftwareVersion;
	HANDLE						hMailSlot;
	DWORD						dwCmdNum;

	LIST_MT						lmtUsersList;
	USER_DATA					udUserData;						// owner data

	char						szComputerName[(MAX_COMPUTERNAME_LENGTH+4)];
	SIZE_T						dwComputerNameLen;				// *

	TCHAR						szSettingsFileName[MAX_PATH_LEN];
	SIZE_T						dwSettingsFileNameLen;			// *
};

static PROCESS_SETTINGS			psProcessSettings;


LPCTSTR lpcszMainSectionName=TEXT("Main");
LPCTSTR lpcszWindowSettingsName=TEXT("WindowSettings");
LPCTSTR lpcszShowExtendedInfoName=TEXT("ShowExtendedInfo");
LPCTSTR lpcszNickName=TEXT("Nick");
LPCTSTR lpcszStatusName=TEXT("Status");
LPCTSTR lpcszStatusMSGName=TEXT("StatusMSG");

#define MEMALLOC(Size)				HeapAlloc(psProcessSettings.hMemAllocHandle,HEAP_ZERO_MEMORY,(Size+sizeof(SIZE_T)))
#define MEMREALLOC(Mem,Size)		HeapReAlloc(psProcessSettings.hMemAllocHandle,(HEAP_ZERO_MEMORY),(LPVOID)Mem,(Size+sizeof(SIZE_T)))
#define MEMFREE(Mem)				if (Mem) {HeapFree(psProcessSettings.hMemAllocHandle,0,(LPVOID)Mem);Mem=NULL;}
#define GET_WINDOW_DATA(hWndDlg)	((USER_DATA*)GetWindowLongPtr(hWndDlg,GWL_USERDATA))


BOOL				WritePrivateProfileInt		(LPCTSTR lpAppName,LPCTSTR lpKeyName,INT nValue,LPCTSTR lpFileName);

LRESULT CALLBACK	WndProcMainDialog			(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK	WndProcMainDialogSendProc	(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK		WndProcUserInfoDialog		(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);

VOID CALLBACK		MailSlotReadTimerProc		(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
VOID CALLBACK		RefreshTimerProc			(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
DWORD				CommandDispather			(LPBYTE lpbData,SIZE_T dwDataSize);
void				DisplayOnScreenTextA		(LPCSTR lpcszText,SIZE_T dwTextLen);
void				DisplayError				(DWORD dwErrorCode);
DWORD				SendText					();


#define IC_FLAG_NO_INC_COUNTER		1
#define IC_FLAG_ALL_IC_VERSIONS		2
#define IC_FLAG_
#define IC_FLAG_
DWORD				ICDisconnect				(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize);
DWORD				ICConnect					(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszLogin,SIZE_T dwLoginSize,LPSTR lpszNick,SIZE_T dwNickSize,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize,DWORD dwStatus);
DWORD				ICCreateLine				(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszPassword,SIZE_T dwPasswordSize,LPSTR lpszSender,SIZE_T dwSenderSize);
DWORD				ICRefresh					(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszLogin,SIZE_T dwLoginSize,LPSTR lpszNick,SIZE_T dwNickSize,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize,DWORD dwStatus);
DWORD				ICStatusReq					(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen);
DWORD				ICStatus					(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,DWORD dwStatus);
DWORD				ICBoard						(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,DWORD dwBoardMSGNum,LPSTR lpszBoardMSG,SIZE_T dwBoardMSGSize);
DWORD				ICText						(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszMSG,SIZE_T dwMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize);
DWORD				ICMe						(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszMSG,SIZE_T dwMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize);
DWORD				ICCrash						(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen);
DWORD				ICSendCmd					(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,DWORD dwCmd,LPVOID lpData,SIZE_T dwDataSize);


void				UsersListDisplayRebuild		();
void				UsersListDisplayUpdate		(USER_DATA *lpUserData);
void				UsersListDisplayDelete		(USER_DATA *lpUserData);
void				UsersListDisplayUserInfo	(USER_DATA *lpUserData);
void				UsersListDisplayUserInfoUpdate(USER_DATA *lpUserData);


DWORD				UsersListInit				();
void				UsersListDestroy			();
DWORD				UsersListFindByComputerName	(LPSTR lpszComputerName,SIZE_T dwComputerNameLen,USER_DATA **plpUserData);
DWORD				UsersListUpdateUser			(LPSTR lpszNick,SIZE_T dwNickLen,LPSTR lpLogin,SIZE_T dwLoginLen,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGLen,LPSTR lpszVersion,SIZE_T dwVersionLen,DWORD dwStatus,DWORD dwSoftwareVersion,DWORD dwCmdNum);
DWORD				UsersListDeleteByComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen);
DWORD				UsersListGetLastCmdNumFromComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen);
DWORD				UsersListGetNickFromComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszNick,SIZE_T *pdwNickLen);
void				UsersListUpdatesCheck		();



int APIENTRY wWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPWSTR lpCmdLine,int nCmdShow)
{
	DWORD dwRet;

	if ((dwRet=CRCFileCheck())==NO_ERROR)
	{//     
		MSG msg;

		ZeroMemory(&psProcessSettings,sizeof(psProcessSettings));
		psProcessSettings.hMemAllocHandle=GetProcessHeap();
		psProcessSettings.hInstance=hInstance;
		psProcessSettings.dwSoftwareVersion=IC_CH_VER_ANTIHACK;
		psProcessSettings.dwCmdNum=1;

		psProcessSettings.dwComputerNameLen=(MAX_COMPUTERNAME_LENGTH+4);
		GetComputerNameA(psProcessSettings.szComputerName,&psProcessSettings.dwComputerNameLen);
		
		psProcessSettings.dwSettingsFileNameLen=GetModuleFileName(NULL,psProcessSettings.szSettingsFileName,MAX_PATH_LEN);
		(*((DWORDLONG*)((LPTSTR)psProcessSettings.szSettingsFileName+(psProcessSettings.dwSettingsFileNameLen-4))))=(*((DWORDLONG*)(TEXT(".ini"))));

		UsersListInit();
		psProcessSettings.hMailSlot=CreateMailslot(TEXT("\\\\.\\mailslot\\ichat047"),0,MAILSLOT_WAIT_FOREVER,NULL);
		if (psProcessSettings.hMailSlot==INVALID_HANDLE_VALUE) ReportError(GetLastError());

		{// load settings
			psProcessSettings.udUserData.bOwner=TRUE;

			psProcessSettings.udUserData.dwLoginLen=(UNLEN+4);
			GetUserNameA(psProcessSettings.udUserData.szLogin,&psProcessSettings.udUserData.dwLoginLen);

			psProcessSettings.udUserData.dwComputerNameLen=(MAX_COMPUTERNAME_LENGTH+4);
			GetComputerNameA(psProcessSettings.udUserData.szComputerName,&psProcessSettings.udUserData.dwComputerNameLen);


			psProcessSettings.bShowExtendedInfo=(BOOL)GetPrivateProfileInt(lpcszMainSectionName,lpcszShowExtendedInfoName,0,psProcessSettings.szSettingsFileName);
			psProcessSettings.udUserData.dwStatus=GetPrivateProfileInt(lpcszMainSectionName,lpcszStatusName,IC_STATUS_OFFLINE,psProcessSettings.szSettingsFileName);

			psProcessSettings.udUserData.dwNickLen=GetPrivateProfileString(lpcszMainSectionName,lpcszNickName,psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.szNick,MAX_PATH,psProcessSettings.szSettingsFileName);
			psProcessSettings.udUserData.dwStatusMSGLen=GetPrivateProfileString(lpcszMainSectionName,lpcszStatusMSGName,NULL,psProcessSettings.udUserData.szStatusMSG,MAX_PATH,psProcessSettings.szSettingsFileName);
		}
		ListMTItemAdd(&psProcessSettings.lmtUsersList,(PCLIST_MT_ITEM)&psProcessSettings.udUserData,&psProcessSettings.udUserData);


		LoadLibrary(TEXT("Riched20.dll"));
		InitCommonControls();

		psProcessSettings.hMainWindow=CreateDialog(hInstance,MAKEINTRESOURCE(IDD_MAINWINDOW),NULL,(DLGPROC)WndProcMainDialog);
		while(GetMessage(&msg,0,0,0)) 
		{
			if (msg.hwnd!=psProcessSettings.hWndSendText)
			{
				if(!IsDialogMessage(psProcessSettings.hMainWindow,&msg))
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}else{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}//*/

		CloseHandle(psProcessSettings.hMailSlot);
		UsersListDestroy();
	}

	if (dwRet!=NO_ERROR) ReportError(dwRet);

return(dwRet);
}


BOOL WritePrivateProfileInt(LPCTSTR lpAppName,LPCTSTR lpKeyName,INT nValue,LPCTSTR lpFileName)
{
	TCHAR szBuff[MAX_PATH];

	wsprintf(szBuff,"%lu",nValue);
return(WritePrivateProfileString(lpAppName,lpKeyName,szBuff,lpFileName));
}
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProcMainDialog(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message){
	case WM_INITDIALOG:
		{
			HICON ico;
			HMENU hMenu;
			LVCOLUMN pcol={0};
			MENUITEMINFO mii={0};

			ico=LoadIcon(NULL,MAKEINTRESOURCE(IDI_INFORMATION));
			SendMessage(hWnd,WM_SETICON,0,(LPARAM)ico);
			SendMessage(hWnd,WM_SETICON,1,(LPARAM)ico);
			DestroyIcon(ico);

			psProcessSettings.hMainWindow=hWnd;
			psProcessSettings.hLogWindow=GetDlgItem(hWnd,IDC_LOG);
			psProcessSettings.hUsersListWindow=GetDlgItem(hWnd,IDC_USERS_LIST);
			psProcessSettings.hWndSendText=GetDlgItem(hWnd,IDC_SEND_TEXT);
			psProcessSettings.uiMailSlotReadTimer=SetTimer(NULL,0,CHECK_TIMER_INTERVAL,MailSlotReadTimerProc);
			psProcessSettings.uiRefreshTimer=SetTimer(NULL,0,REFRESH_TIMER_INTERVAL,RefreshTimerProc);
			psProcessSettings.lngOldSendTextProc=GetWindowLongPtr(psProcessSettings.hWndSendText,GWL_WNDPROC);
			SetWindowLongPtr(psProcessSettings.hWndSendText,GWL_WNDPROC,(LONG_PTR)WndProcMainDialogSendProc);

			SendMessage(psProcessSettings.hLogWindow,EM_AUTOURLDETECT,(WPARAM)TRUE,0);

			psProcessSettings.hSmallIcons=ImageList_Create(GetSystemMetrics(SM_CXSMICON),GetSystemMetrics(SM_CYSMICON),ILC_MASK,1,1);
			ListView_SetImageList(psProcessSettings.hUsersListWindow,psProcessSettings.hSmallIcons,LVSIL_SMALL);

			hMenu=GetMenu(hWnd);
			mii.cbSize=sizeof(mii);
			mii.fMask=(MIIM_BITMAP|MIIM_FTYPE);
			mii.fType=(MFT_STRING|MFT_RADIOCHECK);
			for(DWORD dwIndex=0;dwIndex<6;dwIndex++)
			{
				mii.hbmpItem=LoadBitmap(psProcessSettings.hInstance,MAKEINTRESOURCE(IDB_BITMAP_ST_ONLINE+dwIndex));
				ImageList_Add(psProcessSettings.hSmallIcons,mii.hbmpItem,0);
				SetMenuItemInfo(hMenu,(IDM_MAIN_MENU_STATUS_ONLINE+dwIndex),0,&mii);
			}
	 
			SendMessage(psProcessSettings.hUsersListWindow,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT);
			pcol.iImage=0;
			pcol.iOrder=0;
			pcol.mask=(LVCF_FMT|LVCF_WIDTH|LVCF_TEXT);
			pcol.cchTextMax=0;
			
			pcol.cx=170;
			pcol.iSubItem=0;
			pcol.fmt=LVCFMT_LEFT;
			pcol.pszText=TEXT("Users");
			SendMessage(psProcessSettings.hUsersListWindow,LVM_INSERTCOLUMN,(WPARAM)(int)pcol.iSubItem,(LPARAM)&pcol);
			
			{// load settings
				WINDOWPLACEMENT wndpl={0};

				if (GetPrivateProfileStruct(lpcszMainSectionName,lpcszWindowSettingsName,&wndpl,sizeof(wndpl),psProcessSettings.szSettingsFileName))
				{
					if (wndpl.length==sizeof(wndpl)) SetWindowPlacement(hWnd,&wndpl);
				}
			}
			UsersListDisplayRebuild();
		}
		break;
	case WM_SIZE:
		if (wParam==SIZE_MINIMIZED)
		{
			//if (GetBit(AppOptions.ulViewBits,VB_SHOW_ICON_IN_TRAY) && GetBit(AppOptions.ulViewBits,VB_MINIMIZE_TO_TRAY))
			//{
			//	ShowWindow(hWnd,SW_HIDE);
			//}
		}else{
			int nWidth=LOWORD(lParam);  // width of client area 
			int nHeight=HIWORD(lParam); // height of client area 

			//SendMessage(sbStatusBar.GetHWND(),WM_SIZE,wParam,lParam);

			MoveWindow(psProcessSettings.hLogWindow,		10,				10,				(nWidth-210),	(nHeight-100),		1);
			MoveWindow(psProcessSettings.hWndSendText,		10,				(nHeight-85),	(nWidth-210),	60,					1);
			MoveWindow(psProcessSettings.hUsersListWindow,	(nWidth-190),	10,				180,			(nHeight-35),		1);
			//MoveWindow(GetDlgItem(hWnd,IDD_SEND),			(((nWidth-180)/2)-30),(nHeight-45),	80,			22,					1);

			//UpdateWindow_(sScreen.GetHWND());
			//UpdateWindow_(AppSettings.hWndList);
			//UpdateWindow_(AppSettings.hWndSendText);
			//UpdateWindow_(GetDlgItem(hWnd,IDD_SEND));//*/
			//UpdateWindow_(hWnd);

			//sbStatusBar.SetPartWidth(0,(nWidth-121));
		}
		break;
	case WM_GETMINMAXINFO:
		((LPMINMAXINFO)lParam)->ptMinTrackSize.x=MAIN_WINDOW_MIN_WIGTH;
		((LPMINMAXINFO)lParam)->ptMinTrackSize.y=MAIN_WINDOW_MIN_HEIGHT;
		break;
	case WM_CLOSE:
		SendMessage(hWnd,WM_SIZE,SIZE_MINIMIZED,0);
		//break;
	case WM_QUIT:
		if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
		{
			ICDisconnect("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1));
		}

		{// save settings
			WINDOWPLACEMENT wndpl={0};

			wndpl.length=sizeof(wndpl);
			GetWindowPlacement(hWnd,&wndpl);
			WritePrivateProfileStruct(lpcszMainSectionName,lpcszWindowSettingsName,&wndpl,sizeof(wndpl),psProcessSettings.szSettingsFileName);
		}

		ImageList_Destroy(psProcessSettings.hSmallIcons);
		SetWindowLongPtr(psProcessSettings.hWndSendText,GWL_WNDPROC,psProcessSettings.lngOldSendTextProc);
		KillTimer(NULL,psProcessSettings.uiRefreshTimer);
		KillTimer(NULL,psProcessSettings.uiMailSlotReadTimer);
		EndDialog(hWnd,LOWORD(wParam));
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		break;
	case WM_NOTIFY:
		{
			LPNMHDR pnmh=(LPNMHDR)lParam;

			switch (LOWORD(wParam)){
			case IDC_USERS_LIST:
				switch (pnmh->code){
				case LVN_KEYDOWN:
					{
						LPNMLVKEYDOWN pnkd=(LPNMLVKEYDOWN)lParam;

						if (pnkd->wVKey==9) SetFocus(psProcessSettings.hWndSendText);
						/*if (pnkd->wVKey==10)
						{
							LVITEM lvItem={0};

							lvItem.mask=(LVIF_STATE|LVIF_PARAM);
							lvItem.iItem=SendMessage(psProcessSettings.hUsersListWindow,LVM_GETSELECTIONMARK,0,0);
							lvItem.stateMask=LVIS_SELECTED;

							if (SendMessage(psProcessSettings.hUsersListWindow,LVM_GETITEM,0,(LPARAM)&lvItem))
							{
								UsersListDisplayUserInfo((USER_DATA*)lvItem.lParam);
							}
						}*/
					}
					break;
				case NM_CLICK:
					/*{
						LVITEM lvItem={0};
						LPNMITEMACTIVATE lpnmitem=(LPNMITEMACTIVATE)lParam;

						lvItem.mask=(LVIF_STATE|LVIF_PARAM);
						lvItem.iItem=lpnmitem->iItem;

						if (SendMessage(AppSettings.hWndList,LVM_GETITEM,0,(LPARAM)&lvItem))
						{
						}
					}*/
					break;
				case NM_DBLCLK:
					{
						LVITEM lvItem={0};
						LPNMITEMACTIVATE lpnmitem=(LPNMITEMACTIVATE)lParam;

						lvItem.mask=(LVIF_STATE|LVIF_PARAM);
						lvItem.iItem=lpnmitem->iItem;

						if (SendMessage(psProcessSettings.hUsersListWindow,LVM_GETITEM,0,(LPARAM)&lvItem))
						{
							UsersListDisplayUserInfo((USER_DATA*)lvItem.lParam);
						}
					}
					break;
				case LVN_COLUMNCLICK: //LPNMLISTVIEW pnmv=(LPNMLISTVIEW)lParam;
					SendMessage(hWnd,WM_COMMAND,IDM_MAIN_MENU_REFRESH_USER_LIST,0);
					break;
				}
			}
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDM_MAIN_MENU_USER_SETTINGS:
			/*if (DisplayUserSettingsDialog(AppSettings.hInst,AppSettings.hMainWindow,0,0,&cpMyClientProfile))
			{	
				SendNetPacket(AppSettings.skt,NPT_SET_MY_INFO,sizeof(ClientProfile),&cpMyClientProfile);
			}*/
			break;
		case IDM_MAIN_MENU_OPTIONS:
			//DialogBox(AppSettings.hInst,(LPCTSTR)IDD_OPTIONS,AppSettings.hMainWindow,(DLGPROC)WndProcOptionsDialog);
			break;
		case IDM_MAIN_MENU_EXIT:
			//EndDialog(hWnd,0);
			SendMessage(hWnd,WM_QUIT,0,0);
			break;
		case IDM_MAIN_MENU_CLEAR_SCREEN:
			{	
				CHARRANGE crRange={0,-1};

				SendMessage(psProcessSettings.hLogWindow,EM_EXSETSEL,0,(LPARAM)&crRange);
				SendMessage(psProcessSettings.hLogWindow,EM_REPLACESEL,0,(LPARAM)TEXT(""));
			}
			break;
		case IDM_MAIN_MENU_ALWAYS_ON_TOP:
			{
				HMENU hMenu=GetMenu(hWnd);
				MENUITEMINFO mii={0};

				mii.cbSize=sizeof(MENUITEMINFO);
				mii.fMask=MIIM_STATE;

				if (GetMenuItemInfo(hMenu,LOWORD(wParam),MF_BYCOMMAND,&mii))
				if (mii.fState&MFS_CHECKED)
				{// was on top, now wil be simple
					mii.fState&=~MFS_CHECKED;
					SetMenuItemInfo(hMenu,LOWORD(wParam),MF_BYCOMMAND,&mii);
					SetWindowPos(hWnd,HWND_NOTOPMOST,0,0,0,0,(SWP_NOSIZE|SWP_NOMOVE));
				}else{
					mii.fState|=MFS_CHECKED;
					SetMenuItemInfo(hMenu,LOWORD(wParam),MF_BYCOMMAND,&mii);
					SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,(SWP_NOSIZE|SWP_NOMOVE));
				}
			}
			break;
		case IDM_MAIN_MENU_REFRESH_USER_LIST:
			UsersListUpdatesCheck();
			if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
			{
				ICRefresh("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,"*",1,psProcessSettings.udUserData.dwStatus);
			}else{
				ICStatusReq("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen);
			}
			UsersListDisplayRebuild();
			break;
		case IDM_MAIN_MENU_STATUS_ONLINE:
		case IDM_MAIN_MENU_STATUS_AWAY:
		case IDM_MAIN_MENU_STATUS_DND:
		case IDM_MAIN_MENU_STATUS_OCCUPIED:
		case IDM_MAIN_MENU_STATUS_INVISIBLE:
		case IDM_MAIN_MENU_STATUS_OFFLINE:
			if (psProcessSettings.udUserData.dwStatus!=(LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE))
			{// status changed
				if (psProcessSettings.udUserData.dwStatus>=IC_STATUS_INVISIBLE || (LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE)>=IC_STATUS_INVISIBLE)
				{
					ICDisconnect("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1));
				}

				if ((LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE)<IC_STATUS_INVISIBLE)
				if (psProcessSettings.udUserData.dwStatus>=IC_STATUS_INVISIBLE)
				{
					ICConnect("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,"*",1,(LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE));
				}else{
					ICStatus("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,(LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE));
				}
				psProcessSettings.udUserData.dwStatus=(LOWORD(wParam)-IDM_MAIN_MENU_STATUS_ONLINE);
				UsersListDisplayUpdate(&psProcessSettings.udUserData);
				WritePrivateProfileInt(lpcszMainSectionName,lpcszStatusName,psProcessSettings.udUserData.dwStatus,psProcessSettings.szSettingsFileName);
			}
			break;
		case IDM_MAIN_MENU_ABOUT:
			//DialogBox(AppSettings.hInst,(LPCTSTR)IDD_ABOUT,AppSettings.hMainWindow,(DLGPROC)WndProcAbout);
			break;
		}
		break;
	}
return(FALSE);
}

LRESULT CALLBACK WndProcMainDialogSendProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	LRESULT lRet=0;

	switch (message){
	//case WM_KEYDOWN:
	//case WM_KEYUP:
	case WM_CHAR:
		switch(wParam){
		case 9:
			SetFocus(psProcessSettings.hUsersListWindow);
			break;
		case 10:
			SendText();
			break;
		//case 13:
		//	wParam=10;
		//	SetFocus(AppSettings.hWndSendText);
		//	break;
		}

		if (wParam==9 || wParam==10) break;
	default:
		lRet=CallWindowProc((WNDPROC)psProcessSettings.lngOldSendTextProc,hWnd,message,wParam,lParam);
		break;
	}
return(lRet);
}

BOOL CALLBACK WndProcUserInfoDialog(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	USER_DATA *lpUserData=GET_WINDOW_DATA(hWnd);

	switch(message){
	case WM_INITDIALOG:
		lpUserData=(USER_DATA*)lParam;
		SetWindowLongPtr(hWnd,GWL_USERDATA,(LONG_PTR)lParam);

		SendDlgItemMessage(hWnd,IDC_EDIT_USER_INFO,EM_AUTOURLDETECT,(WPARAM)TRUE,0);
		break;
	case WM_USER:
		{
			TCHAR szBuff[1024];

			wsprintf(szBuff,"Nick: %s\r\nLogin: %s\r\nComputer name: \\\\%s\r\nStatus: %s [%s]\r\nSoftware: %s (%s)\r\nCmdnum: %lu",lpUserData->szNick,lpUserData->szLogin,lpUserData->szComputerName,lpcszStatus[lpUserData->dwStatus],lpUserData->szStatusMSG,lpUserData->szVersion,lpcszSoftwareVersion[lpUserData->dwSoftwareVersion],lpUserData->dwCmdNum);
			SetDlgItemTextA(hWnd,IDC_EDIT_USER_INFO,szBuff);
		}
		break;
	case WM_CLOSE:
	case WM_QUIT:
		EndDialog(hWnd,LOWORD(wParam));
		DestroyWindow(hWnd);
		lpUserData->hInfoWindow=NULL;
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDCLOSE:
			//EndDialog(hWnd,0);
			SendMessage(hWnd,WM_QUIT,0,0);
			break;
		}
		break;
	}
return(FALSE);
}

void DisplayOnScreenTextA(LPCSTR lpcszText,SIZE_T dwTextLen)
{
	CHARRANGE crRange={-1,-1},crSelectedRange;

	SendMessage(psProcessSettings.hLogWindow,EM_EXGETSEL,0,(LPARAM)&crSelectedRange);
	SendMessage(psProcessSettings.hLogWindow,EM_HIDESELECTION,(WPARAM)TRUE,0);
	SendMessage(psProcessSettings.hLogWindow,EM_EXSETSEL,0,(LPARAM)&crRange);
	SendMessage(psProcessSettings.hLogWindow,EM_REPLACESEL,0,(LPARAM)lpcszText);

	SendMessage(psProcessSettings.hLogWindow,EM_EXSETSEL,0,(LPARAM)&crRange);
	//SendMessage(psProcessSettings.hLogWindow,EM_SETCHARFORMAT,(WPARAM)SCF_SELECTION,(LPARAM)&cfFormat);
	
	SendMessage(psProcessSettings.hLogWindow,EM_HIDESELECTION,FALSE,0);
	if (crSelectedRange.cpMin!=crSelectedRange.cpMax)
	{
		SendMessage(psProcessSettings.hLogWindow,EM_EXSETSEL,0,(LPARAM)&crSelectedRange);
	}else{
		SendMessage(psProcessSettings.hLogWindow,EM_EXSETSEL,0,(LPARAM)&crRange);
	}
}

void DisplayError(DWORD dwErrorCode)
{
	HWND hWnd=GetActiveWindow();
	char szErrText[1048]={0},szErrDescription[1024];

	szErrDescription[FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,dwErrorCode,0,szErrDescription,1000,NULL)]=0;
	DisplayOnScreenTextA(szErrText,wsprintf(szErrText,"ERROR %lu: %s",dwErrorCode,szErrDescription));
}



VOID CALLBACK MailSlotReadTimerProc(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	if (psProcessSettings.hMailSlot!=INVALID_HANDLE_VALUE)
	{
		DWORD dwMaxMessageSize,dwNextSize,dwMessageCount,dwReadTimeout,dwReaded;

		if (GetMailslotInfo(psProcessSettings.hMailSlot,&dwMaxMessageSize,&dwNextSize,&dwMessageCount,&dwReadTimeout))
		{
			if (dwMessageCount)
			{// new msg
				BYTE btBuff[65536];

				ReadFile(psProcessSettings.hMailSlot,btBuff,dwNextSize,&dwReaded,NULL);
				RC4(btBuff,dwReaded,(LPBYTE)IC_RC4_PASS,(sizeof(IC_RC4_PASS)-1));
				
				(*((DWORDLONG*)(btBuff+dwReaded)))=0;
				DebugPrintCRLFA((LPSTR)btBuff);
				
				CommandDispather(btBuff,dwReaded);

				//for(DWORD i=0;i<dwReaded;i++) if (btBuff[i]==0) btBuff[i]='|';
				//szBuff[i]=0;
				//CopyMemory((btBuff+i),"\r\n",3);
				//DisplayOnScreenTextA(btBuff,(dwReaded+2));
			}
		}else{
			DisplayError(GetLastError());
		}

		if (psProcessSettings.udUserData.dwStatus<=IC_STATUS_INVISIBLE)
		{
			UsersListUpdatesCheck();
		}
	}
}


VOID CALLBACK RefreshTimerProc(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime)
{
	if (psProcessSettings.hMailSlot!=INVALID_HANDLE_VALUE)
	{
		if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
		{
			ICRefresh("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,"*",1,psProcessSettings.udUserData.dwStatus);
		}else{
			if (psProcessSettings.udUserData.dwStatus==IC_STATUS_INVISIBLE)
			{//  
				ICStatusReq("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen);
			}
		}
	}
}


DWORD SendText()
{
	DWORD dwRet;

	char szTextToSend[65535];
	DWORD dwTextToSendLen;
	LPSTR lpsztm,lpsztm2;
	SYSTEMTIME stTime;

	GetLocalTime(&stTime);

	dwTextToSendLen=GetDlgItemText(psProcessSettings.hMainWindow,IDC_SEND_TEXT,szTextToSend,65535);
	SetDlgItemText(psProcessSettings.hMainWindow,IDC_SEND_TEXT,TEXT(""));

	dwRet=ICText("*",IC_FLAG_ALL_IC_VERSIONS,IC_CH_VER_IGNORY,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),szTextToSend,dwTextToSendLen,NULL,0);

	lpsztm=(LPSTR)MEMALLOC(dwTextToSendLen+2048);
	if (lpsztm)
	{
		lpsztm2=lpsztm;
		if (psProcessSettings.bShowExtendedInfo)
		{
			lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s {%s/%s}: ",stTime.wHour,stTime.wMinute,stTime.wSecond,psProcessSettings.udUserData.szNick,IC_MAIN_CHANNEL,"*");
		}else{
			lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s: ",stTime.wHour,stTime.wMinute,stTime.wSecond,psProcessSettings.udUserData.szNick);
		}

		CopyMemory(lpsztm2,szTextToSend,dwTextToSendLen);lpsztm2+=dwTextToSendLen;
		CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
		DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

		MEMFREE(lpsztm);
	}

return(dwRet);
}


DWORD CommandDispather(LPBYTE lpbData,SIZE_T dwDataSize)
{
	DWORD dwRet=0;

	if (dwDataSize>IC_HEAD_SIZE)
	//if ((*((DWORDLONG*)lpbData))==(*((DWORDLONG*)IC_HEAD)))
	//if ((*((DWORDLONG*)lpbData))==(*((DWORDLONG*)IC_HEAD_AH)))
	{
		char szNick[MAX_PATH];
		BOOL bNewConnected;
		WORD wDelimiter=ICDELIMITER;
		DWORD dwSoftwareVersion,dwCmdNum,dwStatus,dwBoardNum;
		LPSTR lpsztm,lpsztm2,lpszCounter,lpszComputerName,lpszCMD,lpszParams,lpszLine,lpszMSG,lpszLogin,lpszNick,lpszStatusNum,lpszStatusMSG,lpszBoardNum,lpszBoardMSG,lpszRecipient,lpszVersion;
		SIZE_T i,dwCMD,dwCounterSize,dwComputerNameSize,dwCMDSize,dwParamsSize,dwLineSize,dwMSGSize,dwLoginSize,dwNickSize,dwStatusNumSize,dwStatusMSGSize,dwBoardNumSize,dwBoardMSGSize,dwRecipientSize,dwVersionSize;
		SYSTEMTIME stTime;

		GetLocalTime(&stTime);

		dwSoftwareVersion=IC_CH_VER_UNKNOWN;
		for(i=0;i<IC_CH_VER_UNKNOWN;i++)
		{
			if ((*((DWORDLONG*)lpbData))==(*((DWORDLONG*)IC_HEADS[i])))
			{
				dwSoftwareVersion=(DWORD)i;
				break;
			}
		}

		lpszCounter=(LPSTR)(lpbData+IC_HEAD_SIZE);
		lpsztm=(LPSTR)MemoryFind(((LPBYTE)lpszCounter-lpbData),lpbData,dwDataSize,&wDelimiter,sizeof(WORD));
		if (lpsztm)
		{
			(*((WORD*)lpsztm))=0;
			dwCounterSize=(lpsztm-lpszCounter);
			lpszComputerName=(lpsztm+sizeof(WORD));
			lpsztm=(LPSTR)MemoryFind(((LPBYTE)lpszComputerName-lpbData),lpbData,dwDataSize,&wDelimiter,sizeof(WORD));
			if (lpsztm)
			{
				(*((WORD*)lpsztm))=0;
				dwComputerNameSize=(lpsztm-lpszComputerName);
				dwCmdNum=StrToUNum32(lpszCounter,dwCounterSize);

				if (MemoryCompare(lpszComputerName,dwComputerNameSize,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen)!=CSTR_EQUAL)
				if (dwCmdNum!=UsersListGetLastCmdNumFromComputerName(lpszComputerName,dwComputerNameSize))
				//if (TRUE)
				{// check message source
					lpszCMD=(lpsztm+sizeof(WORD));
					lpsztm=(LPSTR)MemoryFind(((LPBYTE)lpszCMD-lpbData),lpbData,dwDataSize,&wDelimiter,sizeof(WORD));
					if (lpsztm)
					{
						(*((WORD*)lpsztm))=0;
						dwCMDSize=(lpsztm-lpszCMD);
						lpszParams=(lpsztm+sizeof(WORD));
						dwParamsSize=(dwDataSize-((LPBYTE)lpszParams-lpbData)-1);
					}else{
						dwCMDSize=(dwDataSize-((LPBYTE)lpszCMD-lpbData)-1);
						(*((WORD*)(lpszCMD+dwCMDSize)))=0;
						lpszParams=NULL;
						dwParamsSize=0;
					}

					dwCMD=-1;
					for(i=0;i<IC_MAX_CMD;i++)
					{
						if (MemoryCompare(lpszCMD,dwCMDSize,lpcszCmd[i],dwcCmdSize[i])==CSTR_EQUAL)
						{
							dwCMD=i;
							break;
						}
					}

					if ((bNewConnected=(UsersListUpdateUser(NULL,0,NULL,0,lpszComputerName,dwComputerNameSize,NULL,0,NULL,0,-1,dwSoftwareVersion,dwCmdNum)==ERROR_NOT_FOUND)))
					{// not in list, request info//***deb
						if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
						{//**deb add board
							if (dwCMD!=IC_CMD_CONNECT)
							{
								ICConnect(lpszComputerName,0,dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,lpszComputerName,dwComputerNameSize,psProcessSettings.udUserData.dwStatus);
							}
						}else{
							if (psProcessSettings.udUserData.dwStatus==IC_STATUS_INVISIBLE)
							{
								ICStatusReq(lpszComputerName,0,dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen);
							}
						}
					}
					UsersListGetNickFromComputerName(lpszComputerName,dwComputerNameSize,szNick,NULL);

					switch(dwCMD){
					case IC_CMD_DISCONNECT:
						lpszLine=lpszParams;
						dwLineSize=dwParamsSize;
						(*((WORD*)(lpszLine+dwLineSize)))=0;

						if (psProcessSettings.bShowExtendedInfo)
						{
							lpsztm=(LPSTR)MEMALLOC(dwComputerNameSize+dwParamsSize+2048);
							if (lpsztm)
							{
								lpsztm2=lpsztm;
								lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s {%s/*} disconnected",stTime.wHour,stTime.wMinute,stTime.wSecond,szNick,lpszLine);

								CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
								DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

								MEMFREE(lpsztm);
							}
						}
						if (MemoryCompare(lpszLine,dwLineSize,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1))==CSTR_EQUAL) UsersListDeleteByComputerName(lpszComputerName,dwComputerNameSize);
						break;
					case IC_CMD_CONNECT:
					case IC_CMD_REFRESH:
						lpszLine=lpszParams;
						lpsztm=(LPSTR)MemoryFind((lpszParams-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
						if (lpsztm)
						{
							(*((WORD*)lpsztm))=0;
							dwLineSize=(lpsztm-lpszLine);
							lpszLogin=(lpsztm+sizeof(WORD));
							lpsztm=(LPSTR)MemoryFind((lpszLogin-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
							if (lpsztm)
							{
								(*((WORD*)lpsztm))=0;
								dwLoginSize=(lpsztm-lpszLogin);
								lpszNick=(lpsztm+sizeof(WORD));
								lpsztm=(LPSTR)MemoryFind((lpszNick-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
								if (lpsztm)
								{
									(*((WORD*)lpsztm))=0;
									dwNickSize=(lpsztm-lpszNick);
									lpszStatusMSG=(lpsztm+sizeof(WORD)+sizeof(WORD));
									lpsztm=(LPSTR)MemoryFind((lpszStatusMSG-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
									if (lpsztm)
									{
										(*((WORD*)lpsztm))=0;
										dwStatusMSGSize=(lpsztm-lpszStatusMSG);
										lpszRecipient=(lpsztm+sizeof(WORD));
										lpsztm=(LPSTR)MemoryFind((lpszStatusMSG-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
										if (lpsztm)
										{
											(*((WORD*)lpsztm))=0;
											dwRecipientSize=(lpsztm-lpszRecipient);
											lpszVersion=(lpsztm+sizeof(WORD));
											lpsztm=(LPSTR)MemoryFind((lpszStatusMSG-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
											if (lpsztm)
											{
												(*((WORD*)lpsztm))=0;
												dwVersionSize=(lpsztm-lpszVersion);
												lpszStatusNum=(lpsztm+sizeof(WORD));
												dwStatusNumSize=(dwParamsSize-(lpszStatusNum-lpszParams));
												dwStatus=StrToUNum32(lpszStatusNum,dwStatusNumSize);

												UsersListUpdateUser(lpszNick,dwNickSize,lpszLogin,dwLoginSize,lpszComputerName,dwComputerNameSize,lpszStatusMSG,dwStatusMSGSize,lpszVersion,dwVersionSize,dwStatus,dwSoftwareVersion,dwCmdNum);

												if (dwCMD==IC_CMD_CONNECT)
												{
													if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
													{//**deb add board
														ICConnect(lpszComputerName,0,dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,lpszComputerName,dwComputerNameSize,psProcessSettings.udUserData.dwStatus);
													}

													if (bNewConnected)
													if (psProcessSettings.bShowExtendedInfo)
													{
														lpsztm=(LPSTR)MEMALLOC(dwComputerNameSize+dwParamsSize+2048);
														if (lpsztm)
														{
															lpsztm2=lpsztm;
															lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s (%s/%s) (ver.: %s (%s)) {%s/%s} connected: ",stTime.wHour,stTime.wMinute,stTime.wSecond,lpszNick,lpszComputerName,lpszLogin,lpszVersion,lpcszSoftwareVersion[dwSoftwareVersion],lpszLine,lpszRecipient);

															CopyMemory(lpsztm2,lpszStatusMSG,dwStatusMSGSize);lpsztm2+=dwStatusMSGSize;
															CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
															DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

															MEMFREE(lpsztm);
														}
													}
												}
											}
										}
									}
								}
							}
						}
						break;
					//case IC_CMD_CREATE_LINE:
					//	break;
					case IC_CMD_STATUS_REQ:
						if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
						{
							ICStatus(lpszComputerName,0,dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,psProcessSettings.udUserData.dwStatus);
						}
						break;
					case IC_CMD_STATUS:
						lpszStatusNum=lpszParams;
						lpsztm=(LPSTR)MemoryFind((lpszStatusNum-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
						if (lpsztm)
						{
							(*((WORD*)lpsztm))=0;
							dwStatusNumSize=(lpsztm-lpszStatusNum);
							lpszStatusMSG=(lpsztm+sizeof(WORD));
							dwStatusMSGSize=(dwParamsSize-(lpszStatusMSG-lpszParams));
							dwStatus=StrToUNum32(lpszStatusNum,dwStatusNumSize);

							UsersListUpdateUser(NULL,0,NULL,0,lpszComputerName,dwComputerNameSize,lpszStatusMSG,dwStatusMSGSize,NULL,0,dwStatus,dwSoftwareVersion,dwCmdNum);
						}
						break;
					case IC_CMD_BOARD:
						lpszBoardNum=lpszParams;
						lpsztm=(LPSTR)MemoryFind((lpszBoardNum-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
						if (lpsztm)
						{
							(*((WORD*)lpsztm))=0;
							dwBoardNumSize=(lpsztm-lpszBoardNum);
							lpszBoardMSG=(lpsztm+sizeof(WORD));
							dwBoardMSGSize=(dwParamsSize-(lpszBoardMSG-lpszParams));
							dwBoardNum=StrToUNum32(lpszBoardNum,dwBoardNumSize);

							lpsztm=(LPSTR)MEMALLOC(dwComputerNameSize+dwParamsSize+2048);
							if (lpsztm)
							{
								lpsztm2=lpsztm;
								lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s Board message(%lu) update: ",stTime.wHour,stTime.wMinute,stTime.wSecond,szNick,dwBoardNum);

								CopyMemory(lpsztm2,lpszBoardMSG,dwBoardMSGSize);lpsztm2+=dwBoardMSGSize;
								CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
								DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

								MEMFREE(lpsztm);
							}
							//UsersListUpdateUser(NULL,0,NULL,0,lpszComputerName,dwComputerNameSize,lpszStatusMSG,dwStatusMSGSize,NULL,0,dwStatus,dwSoftwareVersion,dwCmdNum);
						}
						break;
					case IC_CMD_TEXT:
					case IC_CMD_ME:
						lpszLine=lpszParams;
						lpsztm=(LPSTR)MemoryFind((lpszParams-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
						if (lpsztm)
						{
							(*((WORD*)lpsztm))=0;
							dwLineSize=(lpsztm-lpszLine);
							lpszMSG=(lpsztm+sizeof(WORD));
							lpsztm=(LPSTR)MemoryFind((lpszMSG-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
							if (lpsztm)
							{
								(*((WORD*)lpsztm))=0;
								dwMSGSize=(lpsztm-lpszMSG);
								lpszRecipient=(lpsztm+sizeof(WORD));
								dwRecipientSize=(dwParamsSize-(lpszRecipient-lpszParams));
								(*((WORD*)(lpszRecipient+dwRecipientSize)))=0;

								lpsztm=(LPSTR)MEMALLOC(dwComputerNameSize+dwParamsSize+2048);
								if (lpsztm)
								{
									lpsztm2=lpsztm;
									if (psProcessSettings.bShowExtendedInfo)
									{
										lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s {%s/%s}: ",stTime.wHour,stTime.wMinute,stTime.wSecond,szNick,lpszLine,lpszRecipient);
									}else{
										lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s: ",stTime.wHour,stTime.wMinute,stTime.wSecond,szNick);
									}

									CopyMemory(lpsztm2,lpszMSG,dwMSGSize);lpsztm2+=dwMSGSize;
									CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
									DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

									MEMFREE(lpsztm);
								}
							}
						}
						break;
					//case IC_CMD_RECIEVED:
					//	break;
					case IC_CMD_RENAME:
						lpszNick=lpszParams;
						lpsztm=(LPSTR)MemoryFind((lpszNick-lpszParams),lpszParams,dwParamsSize,&wDelimiter,sizeof(WORD));
						if (lpsztm)
						{
							(*((WORD*)lpsztm))=0;
							dwNickSize=(lpsztm-lpszNick);

							UsersListUpdateUser(lpszNick,dwNickSize,NULL,0,lpszComputerName,dwComputerNameSize,NULL,0,NULL,0,-1,dwSoftwareVersion,dwCmdNum);
						}
						break;
					default:
						lpsztm=(LPSTR)MEMALLOC(dwComputerNameSize+dwParamsSize+2048);
						if (lpsztm)
						{
							lpsztm2=lpsztm;
							lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s: %s - ",stTime.wHour,stTime.wMinute,stTime.wSecond,szNick,lpszCMD);

							CopyMemory(lpsztm2,lpszParams,dwParamsSize);lpsztm2+=dwParamsSize;
							CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
							DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));

							MEMFREE(lpsztm);
						}
						break;
					}
				}else{
					DebugPrintCRLFA(TEXT("Message from my self"));
				}
			}
		}
	}
return(dwRet);
}


DWORD ICDisconnect(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_DISCONNECT,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICConnect(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszLogin,SIZE_T dwLoginSize,LPSTR lpszNick,SIZE_T dwNickSize,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize,DWORD dwStatus)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize+dwLoginSize+dwNickSize+dwStatusMSGSize+dwRecipientSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszLogin,dwLoginSize);lpbDataCurrent+=dwLoginSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszNick,dwNickSize);lpbDataCurrent+=dwNickSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszStatusMSG,dwStatusMSGSize);lpbDataCurrent+=dwStatusMSGSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszRecipient,dwRecipientSize);lpbDataCurrent+=dwRecipientSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,"1.3b3",5);lpbDataCurrent+=5;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		(*lpbDataCurrent)=(BYTE)('0'+dwStatus);lpbDataCurrent++;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_CONNECT,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICCreateLine(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszPassword,SIZE_T dwPasswordSize,LPSTR lpszSender,SIZE_T dwSenderSize)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize+dwPasswordSize+dwSenderSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszPassword,dwPasswordSize);lpbDataCurrent+=dwPasswordSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszSender,dwSenderSize);lpbDataCurrent+=dwSenderSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_CREATE_LINE,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICRefresh(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszLogin,SIZE_T dwLoginSize,LPSTR lpszNick,SIZE_T dwNickSize,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize,DWORD dwStatus)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize+dwLoginSize+dwNickSize+dwStatusMSGSize+dwRecipientSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszLogin,dwLoginSize);lpbDataCurrent+=dwLoginSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszNick,dwNickSize);lpbDataCurrent+=dwNickSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszStatusMSG,dwStatusMSGSize);lpbDataCurrent+=dwStatusMSGSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszRecipient,dwRecipientSize);lpbDataCurrent+=dwRecipientSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,"1.3b3",5);lpbDataCurrent+=5;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		(*lpbDataCurrent)=(BYTE)('0'+dwStatus);lpbDataCurrent++;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_REFRESH,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICStatusReq(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen)
{
return(ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_STATUS_REQ,NULL,0));
}

DWORD ICStatus(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGSize,DWORD dwStatus)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwStatusMSGSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		(*lpbDataCurrent)=(BYTE)('0'+dwStatus);lpbDataCurrent++;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszStatusMSG,dwStatusMSGSize);lpbDataCurrent+=dwStatusMSGSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_STATUS,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICBoard(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,DWORD dwBoardMSGNum,LPSTR lpszBoardMSG,SIZE_T dwBoardMSGSize)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwBoardMSGSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		(*lpbDataCurrent)=(BYTE)('0'+dwBoardMSGNum);lpbDataCurrent++;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszBoardMSG,dwBoardMSGSize);lpbDataCurrent+=dwBoardMSGSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_BOARD,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICText(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszMSG,SIZE_T dwMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize+dwMSGSize+dwRecipientSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszMSG,dwMSGSize);lpbDataCurrent+=dwMSGSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszRecipient,dwRecipientSize);lpbDataCurrent+=dwRecipientSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_TEXT,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}

DWORD ICMe(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszLine,SIZE_T dwLineSize,LPSTR lpszMSG,SIZE_T dwMSGSize,LPSTR lpszRecipient,SIZE_T dwRecipientSize)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwLineSize+dwMSGSize+dwRecipientSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszMSG,dwMSGSize);lpbDataCurrent+=dwMSGSize;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		CopyMemory(lpbDataCurrent,lpszRecipient,dwRecipientSize);lpbDataCurrent+=dwRecipientSize;

		dwRet=ICSendCmd(lpszDest,dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_ME,lpBuff,(lpbDataCurrent-lpBuff));
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}


DWORD ICCrash(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen)
{
	DWORD dwRet=NO_ERROR;
	LPBYTE lpBuff,lpbDataCurrent;
	//HCRYPTPROV hProv;

	//CryptAcquireContext(&hProv,0,0,PROV_RSA_FULL,CRYPT_VERIFYCONTEXT);

	lpBuff=(LPBYTE)MEMALLOC(2048);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;

		//CopyMemory(lpbDataCurrent,lpszLine,dwLineSize);lpbDataCurrent+=dwLineSize;
		//(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		//CopyMemory(lpbDataCurrent,lpszMSG,dwMSGSize);lpbDataCurrent+=dwMSGSize;
		//(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		//CopyMemory(lpbDataCurrent,lpszRecipient,dwRecipientSize);lpbDataCurrent+=dwRecipientSize;

		(*lpbDataCurrent)=(BYTE)('0'+0);lpbDataCurrent++;
		(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
		//CopyMemory(lpbDataCurrent,lpszStatusMSG,dwStatusMSGSize);lpbDataCurrent+=dwStatusMSGSize;


		//for (DWORD cmd=0;cmd<IC_MAX_CMD;cmd++)
		//{
		//	CryptGenRandom(hProv,1024,lpBuff);
			for(DWORD i=0;i<100;i++)
			{
				for(DWORD j=0;j<6;j++)
				{
					(*lpBuff)=(BYTE)('0'+j);
					dwRet=ICSendCmd("*",dwFlags,dwSoftwareVersion,lpszComputerName,dwComputerNameLen,IC_CMD_STATUS,lpBuff,(lpbDataCurrent-lpBuff));
				}
			}
		//}
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
	//CryptReleaseContext(hProv,0);
return(dwRet);
}



DWORD ICSendCmd(LPSTR lpszDest,DWORD dwFlags,DWORD dwSoftwareVersion,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,DWORD dwCmd,LPVOID lpData,SIZE_T dwDataSize)
{
	DWORD dwRet=NO_ERROR;
	DWORD dwtm;
	CHAR szDestination[MAX_PATH];
	LPBYTE lpBuff,lpbDataCurrent;
	HANDLE hFile;

	lpBuff=(LPBYTE)MEMALLOC(2048+dwComputerNameLen+dwDataSize);
	if (lpBuff)
	{
		lpbDataCurrent=lpBuff;
		wsprintfA(szDestination,"\\\\%s\\mailslot\\ichat047",lpszDest);
		hFile=CreateFileA(szDestination,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if (hFile!=INVALID_HANDLE_VALUE)
		{
			lpbDataCurrent+=IC_HEAD_SIZE;
			lpbDataCurrent+=wsprintfA((LPSTR)lpbDataCurrent,"%lu",psProcessSettings.dwCmdNum);
			(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
			CopyMemory(lpbDataCurrent,lpszComputerName,dwComputerNameLen);lpbDataCurrent+=dwComputerNameLen;
			(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
			CopyMemory(lpbDataCurrent,lpcszCmd[dwCmd],dwcCmdSize[dwCmd]);lpbDataCurrent+=dwcCmdSize[dwCmd];
			if (dwDataSize)
			{
				(*((WORD*)lpbDataCurrent))=ICDELIMITER;lpbDataCurrent+=sizeof(WORD);
				CopyMemory(lpbDataCurrent,lpData,dwDataSize);lpbDataCurrent+=dwDataSize;
			}
			(*lpbDataCurrent)=19;lpbDataCurrent++;

			if (dwFlags&IC_FLAG_ALL_IC_VERSIONS)
			{
				for(SIZE_T i=0;i<IC_CH_VER_UNKNOWN;i++)
				{
					(*((DWORDLONG*)lpBuff))=(*((DWORDLONG*)IC_HEADS[i]));
					RC4(lpBuff,(lpbDataCurrent-lpBuff),(LPBYTE)IC_RC4_PASS,(sizeof(IC_RC4_PASS)-1));
					WriteFile(hFile,lpBuff,(DWORD)(lpbDataCurrent-lpBuff),&dwtm,NULL);
					RC4(lpBuff,(lpbDataCurrent-lpBuff),(LPBYTE)IC_RC4_PASS,(sizeof(IC_RC4_PASS)-1));
				}
			}else{
				if (dwSoftwareVersion>=IC_CH_VER_UNKNOWN) dwSoftwareVersion=IC_CH_VER_ORIG;
				(*((DWORDLONG*)lpBuff))=(*((DWORDLONG*)IC_HEADS[dwSoftwareVersion]));
				RC4(lpBuff,(lpbDataCurrent-lpBuff),(LPBYTE)IC_RC4_PASS,(sizeof(IC_RC4_PASS)-1));
				WriteFile(hFile,lpBuff,(DWORD)(lpbDataCurrent-lpBuff),&dwtm,NULL);
			}
			CloseHandle(hFile);

			if ((dwFlags&IC_FLAG_NO_INC_COUNTER)==0) psProcessSettings.dwCmdNum++;
		}else{
			DisplayError(GetLastError());
		}
		MEMFREE(lpBuff);
	}else{
		 DisplayError(GetLastError());
	}
return(dwRet);
}





void UsersListDisplayRebuild()
{
	USER_DATA *lpUserData;
	TCHAR szText[MAX_PATH];
	LVITEM lvItem={0};
	LV_FINDINFO lvfi={0};
	LIST_MT_ITERATOR lmtiIterator;

	lvfi.flags=LVFI_PARAM;

	lvItem.mask=(LVIF_STATE|LVIF_PARAM);
	lvItem.stateMask=LVIS_SELECTED;
	lvItem.iItem=(int)SendMessage(psProcessSettings.hUsersListWindow,LVM_GETSELECTIONMARK,0,0);
	if (SendMessage(psProcessSettings.hUsersListWindow,LVM_GETITEM,0,(LPARAM)&lvItem)) lvfi.lParam=lvItem.lParam;
	SendMessage(psProcessSettings.hUsersListWindow,LVM_DELETEALLITEMS,0,0);

	ZeroMemory(&lvItem,sizeof(lvItem));
	lvItem.cchTextMax=128;
	lvItem.mask=(LVIF_TEXT|LVIF_PARAM|LVIF_IMAGE);
	
	ListMTLock(&psProcessSettings.lmtUsersList);
	ListMTIteratorMoveFirst(&psProcessSettings.lmtUsersList,&lmtiIterator);
	do
	{// 
		if (ListMTIteratorGet(&lmtiIterator,NULL,(LPVOID*)&lpUserData)==NO_ERROR)
		{
			wsprintf(szText,"%s [%s@%s]",lpUserData->szNick,lpUserData->szLogin,lpUserData->szComputerName);

			lvItem.iImage=lpUserData->dwStatus;
			lvItem.lParam=(LPARAM)lpUserData;
			lvItem.pszText=szText;//**deb
			SendMessage(psProcessSettings.hUsersListWindow,LVM_INSERTITEM,(WPARAM)0,(LPARAM)&lvItem);
		}
	}while(ListMTIteratorMoveNext(&lmtiIterator));
	ListMTUnLock(&psProcessSettings.lmtUsersList);
	
	SendMessage(psProcessSettings.hUsersListWindow,LVM_SETSELECTIONMARK,0,SendMessage(psProcessSettings.hUsersListWindow,LVM_FINDITEM,(WPARAM)-1,(LPARAM)&lvfi));
}

void UsersListDisplayUpdate(USER_DATA *lpUserData)
{
	if (lpUserData)
	{
		TCHAR szText[MAX_PATH];
		LVITEM lvItem={0};
		LV_FINDINFO lvfi={0};

		lvfi.flags=LVFI_PARAM;
		lvfi.lParam=(LPARAM)lpUserData;

		wsprintf(szText,"%s [%s@%s]",lpUserData->szNick,lpUserData->szLogin,lpUserData->szComputerName);

		lvItem.cchTextMax=128;
		lvItem.iImage=lpUserData->dwStatus;
		lvItem.iIndent=0;
		lvItem.iItem=(int)SendMessage(psProcessSettings.hUsersListWindow,LVM_FINDITEM,(WPARAM)-1,(LPARAM)&lvfi);;
		lvItem.lParam=(LPARAM)lpUserData;
		lvItem.mask=(LVIF_TEXT|LVIF_PARAM|LVIF_IMAGE);
		lvItem.state=0;
		lvItem.stateMask=0;
		lvItem.iSubItem=0;
		lvItem.pszText=szText;
		if (lvItem.iItem!=-1)
		{
			SendMessage(psProcessSettings.hUsersListWindow,LVM_SETITEM,(WPARAM)0,(LPARAM)&lvItem);
		}else{
			lvItem.iItem=0;
			SendMessage(psProcessSettings.hUsersListWindow,LVM_INSERTITEM,(WPARAM)0,(LPARAM)&lvItem);
		}
		UsersListDisplayUserInfoUpdate(lpUserData);
	}
}


void UsersListDisplayDelete(USER_DATA *lpUserData)
{
	LV_FINDINFO lvfi={0};

	lvfi.flags=LVFI_PARAM;
	lvfi.lParam=(LPARAM)lpUserData;
	SendMessage(psProcessSettings.hUsersListWindow,LVM_DELETEITEM,(WPARAM)SendMessage(psProcessSettings.hUsersListWindow,LVM_FINDITEM,(WPARAM)-1,(LPARAM)&lvfi),0);
}

void UsersListDisplayUserInfo(USER_DATA *lpUserData)
{
	if (lpUserData)
	{
		if (lpUserData->hInfoWindow==NULL)
		{
			lpUserData->hInfoWindow=CreateDialogParam(psProcessSettings.hInstance,MAKEINTRESOURCE(IDD_DIALOG_USER_INFO),NULL,WndProcUserInfoDialog,(LPARAM)lpUserData);
		}
		SendMessage(lpUserData->hInfoWindow,WM_USER,0,0);
	}
}

void UsersListDisplayUserInfoUpdate(USER_DATA *lpUserData)
{
	if (lpUserData)	SendMessage(lpUserData->hInfoWindow,WM_USER,0,0);
}




DWORD UsersListInit()
{
return(ListMTInitialize(&psProcessSettings.lmtUsersList,0));
}

void UsersListDestroy()
{
	USER_DATA *lpUserData;

	ListMTLock(&psProcessSettings.lmtUsersList);
	while(ListMTItemGetFirst(&psProcessSettings.lmtUsersList,NULL,(LPVOID*)&lpUserData)==NO_ERROR)
	{
		ListMTItemDelete(&psProcessSettings.lmtUsersList,&lpUserData->lmtListMTItem);
		if (lpUserData->bOwner==FALSE) MEMFREE(lpUserData);
	}
	ListMTUnLock(&psProcessSettings.lmtUsersList);
	ListMTDestroy(&psProcessSettings.lmtUsersList);
}

DWORD UsersListFindByComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen,USER_DATA **plpUserData)
{
	DWORD dwRet=ERROR_NOT_FOUND;
	USER_DATA *lpUserData;
	LIST_MT_ITERATOR lmtiIterator;

	dwComputerNameLen=min(dwComputerNameLen,(MAX_COMPUTERNAME_LENGTH+2));

	ListMTLock(&psProcessSettings.lmtUsersList);
	ListMTIteratorMoveFirst(&psProcessSettings.lmtUsersList,&lmtiIterator);
	do
	{// 
		if (ListMTIteratorGet(&lmtiIterator,NULL,(LPVOID*)&lpUserData)==NO_ERROR)
		if (MemoryCompare(lpszComputerName,dwComputerNameLen,lpUserData->szComputerName,lpUserData->dwComputerNameLen)==CSTR_EQUAL)
		{
			if (plpUserData) (*plpUserData)=lpUserData;
			dwRet=NO_ERROR;
			break;
		}
	}while(ListMTIteratorMoveNext(&lmtiIterator));
	ListMTUnLock(&psProcessSettings.lmtUsersList);
return(dwRet);
}

DWORD UsersListUpdateUser(LPSTR lpszNick,SIZE_T dwNickLen,LPSTR lpszLogin,SIZE_T dwLoginLen,LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszStatusMSG,SIZE_T dwStatusMSGLen,LPSTR lpszVersion,SIZE_T dwVersionLen,DWORD dwStatus,DWORD dwSoftwareVersion,DWORD dwCmdNum)
{
	DWORD dwRet=NO_ERROR;
	USER_DATA *lpUserData;

	dwNickLen=min(dwNickLen,(MAX_PATH-2));
	dwLoginLen=min(dwLoginLen,(UNLEN+2));
	dwComputerNameLen=min(dwComputerNameLen,(MAX_COMPUTERNAME_LENGTH+2));
	dwStatusMSGLen=min(dwStatusMSGLen,(MAX_PATH-2));
	dwVersionLen=min(dwVersionLen,(MAX_PATH-2));

	ListMTLock(&psProcessSettings.lmtUsersList);
	if ((dwRet=UsersListFindByComputerName(lpszComputerName,dwComputerNameLen,&lpUserData))==ERROR_NOT_FOUND)
	{// not found
		lpUserData=(USER_DATA*)MEMALLOC(sizeof(USER_DATA));
		if (lpUserData)
		{
			ListMTItemAdd(&psProcessSettings.lmtUsersList,(PCLIST_MT_ITEM)lpUserData,lpUserData);
			CopyMemory(lpUserData->szComputerName,lpszComputerName,dwComputerNameLen);
			(*((WORD*)(lpUserData->szComputerName+dwComputerNameLen)))=0;
			lpUserData->dwComputerNameLen=dwComputerNameLen;
			lpUserData->dwStatus=IC_STATUS_INVISIBLE;

			if (lpszNick==NULL)
			{
				lpszNick=lpszComputerName;
				dwNickLen=dwComputerNameLen;
			}
		}else{
			dwRet=GetLastError();
			DisplayError(dwRet);
		}
	}

	if (lpUserData)
	{
		GetLocalTime(&lpUserData->stLastUpdateTime);
		lpUserData->dwRetryCount=0;
		
		if (lpUserData->bOwner==FALSE)
		{
			if (lpszNick)
			{
				CopyMemory(lpUserData->szNick,lpszNick,dwNickLen);
				(*((WORD*)(lpUserData->szNick+dwNickLen)))=0;
				lpUserData->dwNickLen=dwNickLen;
			}

			if (lpszLogin)
			{
				CopyMemory(lpUserData->szLogin,lpszLogin,dwLoginLen);
				(*((WORD*)(lpUserData->szLogin+dwLoginLen)))=0;
				lpUserData->dwLoginLen=dwLoginLen;
			}

			if (lpszStatusMSG)
			{
				CopyMemory(lpUserData->szStatusMSG,lpszStatusMSG,dwStatusMSGLen);
				(*((WORD*)(lpUserData->szStatusMSG+dwStatusMSGLen)))=0;
				lpUserData->dwStatusMSGLen=dwStatusMSGLen;
			}

			if (lpszStatusMSG)
			{
				CopyMemory(lpUserData->szStatusMSG,lpszStatusMSG,dwStatusMSGLen);
				(*((WORD*)(lpUserData->szStatusMSG+dwStatusMSGLen)))=0;
				lpUserData->dwStatusMSGLen=dwStatusMSGLen;
			}

			if (lpszVersion)
			{
				CopyMemory(lpUserData->szVersion,lpszVersion,dwVersionLen);
				(*((WORD*)(lpUserData->szVersion+dwVersionLen)))=0;
				lpUserData->dwVersionLen=dwVersionLen;
			}

			if (dwStatus!=-1) lpUserData->dwStatus=dwStatus;
		}
		lpUserData->dwSoftwareVersion=dwSoftwareVersion;
		if (dwCmdNum) lpUserData->dwCmdNum=dwCmdNum;
		UsersListDisplayUpdate(lpUserData);
	}
	ListMTUnLock(&psProcessSettings.lmtUsersList);

return(dwRet);
}

DWORD UsersListDeleteByComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen)
{
	DWORD dwRet;
	USER_DATA *lpUserData;

	dwComputerNameLen=min(dwComputerNameLen,(MAX_COMPUTERNAME_LENGTH+2));

	ListMTLock(&psProcessSettings.lmtUsersList);
	if ((dwRet=UsersListFindByComputerName(lpszComputerName,dwComputerNameLen,&lpUserData))==NO_ERROR)
	if (lpUserData->bOwner==FALSE)
	{// founded
		ListMTItemDelete(&psProcessSettings.lmtUsersList,&lpUserData->lmtListMTItem);
		UsersListDisplayDelete(lpUserData);
		CloseWindow(lpUserData->hInfoWindow);
		MEMFREE(lpUserData);
	}
	ListMTUnLock(&psProcessSettings.lmtUsersList);

return(dwRet);
}

DWORD UsersListGetNickFromComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen,LPSTR lpszNick,SIZE_T *pdwNickLen)
{
	DWORD dwRet;
	USER_DATA *lpUserData;

	dwComputerNameLen=min(dwComputerNameLen,(MAX_COMPUTERNAME_LENGTH+2));

	ListMTLock(&psProcessSettings.lmtUsersList);
	if ((dwRet=UsersListFindByComputerName(lpszComputerName,dwComputerNameLen,&lpUserData))==NO_ERROR && lpUserData->dwNickLen)
	{// founded
		if (lpszNick)
		{
			CopyMemory(lpszNick,lpUserData->szNick,lpUserData->dwNickLen);
			(*((WORD*)(lpszNick+lpUserData->dwNickLen)))=0;
		}
		if (pdwNickLen) (*pdwNickLen)=lpUserData->dwNickLen;
	}else{// not found, nick=comp name
		if (lpszNick)
		{
			CopyMemory(lpszNick,lpszComputerName,dwComputerNameLen);
			(*((WORD*)(lpszNick+dwComputerNameLen)))=0;
		}
		if (pdwNickLen) (*pdwNickLen)=dwComputerNameLen;
	}
	ListMTUnLock(&psProcessSettings.lmtUsersList);

return(dwRet);
}

DWORD UsersListGetLastCmdNumFromComputerName(LPSTR lpszComputerName,SIZE_T dwComputerNameLen)
{
	DWORD dwRet;
	USER_DATA *lpUserData;

	dwComputerNameLen=min(dwComputerNameLen,(MAX_COMPUTERNAME_LENGTH+2));

	ListMTLock(&psProcessSettings.lmtUsersList);
	if (UsersListFindByComputerName(lpszComputerName,dwComputerNameLen,&lpUserData)==NO_ERROR)
	{// founded
		dwRet=lpUserData->dwCmdNum;
	}else{// not found, nick=comp name
		dwRet=0;
	}
	ListMTUnLock(&psProcessSettings.lmtUsersList);

return(dwRet);
}

void UsersListUpdatesCheck()
{
	char szBuff[16484];
	LPSTR lpsztm,lpsztm2;
	FILETIME ftCurrentTime,ftExpireTime;
	USER_DATA *lpUserData;
	SYSTEMTIME stTime;
	LIST_MT_ITERATOR lmtiIterator;

	GetLocalTime(&stTime);
	SystemTimeToFileTime(&stTime,&ftCurrentTime);

	ListMTLock(&psProcessSettings.lmtUsersList);
	ListMTIteratorMoveFirst(&psProcessSettings.lmtUsersList,&lmtiIterator);
	do
	{// 
		if (ListMTIteratorGet(&lmtiIterator,NULL,(LPVOID*)&lpUserData)==NO_ERROR)
		if (lpUserData->bOwner==FALSE)
		{
			SystemTimeToFileTime(&lpUserData->stLastUpdateTime,&ftExpireTime);
			(*((DWORDLONG*)&ftExpireTime))+=(FILETIME_SECOND*((DWORDLONG)(UL_USER_UPDATE_TIME+(lpUserData->dwRetryCount*UL_RETRY_PING_WAIT))));

			if ((*((DWORDLONG*)&ftExpireTime))<(*((DWORDLONG*)&ftCurrentTime)))
			{// need update
				if (lpUserData->dwRetryCount<UL_RETRY_COUNT_MAX)
				{// ping them
					lpUserData->dwRetryCount++;
					if (psProcessSettings.udUserData.dwStatus<IC_STATUS_INVISIBLE)
					{
						ICRefresh(lpUserData->szComputerName,0,lpUserData->dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen,IC_MAIN_CHANNEL,(sizeof(IC_MAIN_CHANNEL)-1),psProcessSettings.udUserData.szLogin,psProcessSettings.udUserData.dwLoginLen,psProcessSettings.udUserData.szNick,psProcessSettings.udUserData.dwNickLen,psProcessSettings.udUserData.szStatusMSG,psProcessSettings.udUserData.dwStatusMSGLen,"*",1,psProcessSettings.udUserData.dwStatus);
					}else{
						if (psProcessSettings.udUserData.dwStatus==IC_STATUS_INVISIBLE)
						{//  
							ICStatusReq(lpUserData->szComputerName,0,lpUserData->dwSoftwareVersion,psProcessSettings.szComputerName,psProcessSettings.dwComputerNameLen);
						}
					}
				}else{// user dead
					if (psProcessSettings.bShowExtendedInfo)
					{
						lpsztm=szBuff;
						lpsztm2=lpsztm;
						lpsztm2+=wsprintfA(lpsztm2,"[%02lu:%02lu:%02lu] %s (%s/%s) (ver.: %s (%s)) lost connection/time out",stTime.wHour,stTime.wMinute,stTime.wSecond,lpUserData->szNick,lpUserData->szComputerName,lpUserData->szLogin,lpUserData->szVersion,lpcszSoftwareVersion[lpUserData->dwSoftwareVersion]);
						CopyMemory(lpsztm2,"\r\n",3);lpsztm2+=3;
						DisplayOnScreenTextA(lpsztm,(lpsztm2-lpsztm));
					}
					UsersListDeleteByComputerName(lpUserData->szComputerName,lpUserData->dwComputerNameLen);
					ListMTIteratorMoveFirst(&psProcessSettings.lmtUsersList,&lmtiIterator);// prevent damage iterator
				}
			}
		}
	}while(ListMTIteratorMoveNext(&lmtiIterator));
	ListMTUnLock(&psProcessSettings.lmtUsersList);
}